#include <game.h>

#include <iostream>
#include <fstream>
#include <string>
#include <sys/types.h>
#include <sys/stat.h>

//TODO: Don't check if all logs are closed when close
//TODO: Ajouter possibilité de pas logguer pour accélerer
//TODO: Virer irrlicht de l'affaire se qui permettre un log après sa fermeture
//TODO: permettra de virer les appels au coeur depuis cette classe et peut etre aussi depuis base
//TODO: permettant de faire deriver startmenu de base
//TODO:can use irr device to log
//TODO:log error


logger::logger() : base("logger")
{
	files = new std::vector<std::ofstream*>;
}

logger::~logger()
{
	delete files;
}

int logger::init(coeur* c)
{
	base::init(0,c);
	return 1;
}

int logger::close()
{
	base::close();
	return 1;
}

int logger::createFile(stringc name, int idClass)
{
	int idLog = files->size();
	stringc path = "log/";
	mkdir(path.c_str(),01777);
	path += name + "/";
	mkdir(path.c_str(),01777);
	path += stringc(idClass) + ".log";
	std::ofstream* file = new std::ofstream(path.c_str());
	files->push_back(file);
	write(idLog,stringc("Class : " ) + name);
	write(idLog,stringc("Id :  ") + stringc(idClass));
	write(idLog,stringc("Begin log" ));
	write(idLog,stringc("------------------------------------------------------------"));
	if (name != stringc("logger"))
		log( stringc("Logger create a new file for class ") + name + " of id " + stringc(idClass) + ". The log id is " + stringc(idLog));
	else
		write(idLog, stringc("The log id of this logger is ") + stringc(idLog));
	return idLog;
}

int logger::write(int idLog,stringc text)
{
	text = stringc(mycore->getTime()/1000) + ":" + text + "\n";
	(*files->at(idLog)) << text.c_str();
	files->at(idLog)->flush();
	return 1;
}

int logger::closeFile(int idLog)
{
	log(stringc("Close the log of id ") + stringc(idLog));
	write(idLog,stringc("------------------------------------------------------------"));
	write(idLog,stringc("End log"));
	files->at(idLog)->close();
	delete files->at(idLog);
	return 1;
}


bool logger::OnEvent(const SEvent& event)
{
	return false;
}


